%{
#include <stdio.h>
#include <string.h>
#include "data.h"

/**
** Funcao utilizada pelo Bison
*/
void yyerror(const char *str)
{
	fprintf(stderr,"%s\n",str);
}

/**
** Funcao utilizada pelo Bison
*/
int yywrap()
{
	return 1;
} 


int main(int argc, char *argv[])
{

	
	//! Inicio do Parser

	yyparse();
}


%}

/**
** Tokens definidos no arquivo trace.l
*/
%token NUMBER INT  STRING COMMA SEMICOLON CHAR FLOAT PLUS MINUS TIMES DIVIDE MOD

%%

/**
** Regras de producao sintatica. 
** Observe as chaves. E' possivel agregar informacao semantica junto a esse codigo.
*/
start:
{
	printf(">> start\n");

} commands {printf(">> end\n"); print_ts();}
;

commands:
        |
	commands  command
;

command:INT {strcpy(tipo,"int");} list_str  SEMICOLON	{if (!consulta_ts((char *)yylval)) insere_ts((char *)tipo,(char*)yylval); else {printf("\nVariable already exist!\n"); return 0;}}
        | CHAR {strcpy(tipo,"char");} list_str  SEMICOLON	{if (!consulta_ts((char *)yylval)) insere_ts((char *)tipo,(char *)yylval); else {printf("\nVariable already exist!\n"); return 0;}}  
        | FLOAT {strcpy(tipo,"float");} list_str  SEMICOLON	{if (!consulta_ts((char *)yylval)) insere_ts((char *)tipo,(char *)yylval); else {printf("\nVariable already exist!\n"); return 0;}}
        | expr  


;

list_str:STRING 
         |list_str COMMA {if (!consulta_ts((char *)yylval)) insere_ts((char *)tipo,(char *)yylval); else{ printf("\nVariable already exists!\n"); return 0;}}  STRING
;

expr:  STRING expr1  PLUS STRING expr1 SEMICOLON 
      | STRING expr1 MINUS STRING expr1 SEMICOLON 
      | STRING expr1 TIMES STRING expr1 SEMICOLON
      | STRING expr1 DIVIDE STRING expr1 SEMICOLON
      | STRING expr2 MOD STRING  expr2 SEMICOLON  
;

expr1: {if (!(consulta_ts((char*)yylval)) || (!strcmp(retorna_tipo((char*)yylval),"char"))){ printf("\nInvalid expression!\n"); return 0;}}
;

expr2: {if (!(consulta_ts((char*)yylval)) || (strcmp(retorna_tipo(yylval),"int")!=0)){ printf("\nInvalid expression!\n"); return 0;}}
;


